---------------------------------------------------------------------------------------------------
-- Deeds (Digital Electronics Education and Design Suite)
-- VHDL Code generated on (09/05/2023, 09:01:05)
--      by the Deeds (Finite State Machine Simulator)(Deeds-FsM)
--      Ver. 2.50.200 (Feb 18, 2022)
-- Copyright (c) 2002-2022 University of Genoa, Italy
--      Web Site:  https://www.digitalelectronicsdeeds.com
---------------------------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY Fsm1_Pulser_EN IS
  PORT( ----------------------------------->Clock & Reset:
        Ck:    IN std_logic;
        Reset: IN std_logic;
        ----------------------------------->Inputs:
        i_TRG: IN std_logic;
        i_TC:  IN std_logic;
        ----------------------------------->Outputs:
        o_OUT: OUT std_logic;
        o_LD:  OUT std_logic;
        o_EN:  OUT std_logic
        -------------------------------------------
        );
END Fsm1_Pulser_EN;

ARCHITECTURE behavioral OF Fsm1_Pulser_EN IS       -- (Behavioral Description)
  TYPE states is ( state_rs,
                   state_wt,
                   state_ps,
                   dummy_11 );
  SIGNAL State,
         Next_State: states;
BEGIN

  -- Next State Combinational Logic ----------------------------------
  FSM: process( State, i_TRG, i_TC )
  begin
    CASE State IS
      when state_wt =>
                 if (i_TRG = '1') then
                   Next_State <= state_ps;
                 else
                   Next_State <= state_wt;
                 end if;
      when state_ps =>
                 if (i_TC = '1') then
                   Next_State <= state_rs;
                 else
                   Next_State <= state_ps;
                 end if;
      when state_rs =>
                 if (i_TRG = '1') then
                   Next_State <= state_rs;
                 else
                   Next_State <= state_wt;
                 end if;
      when OTHERS =>
                 Next_State <= state_rs;
    END case;
  end process;

  -- State Register --------------------------------------------------
  REG: process( Ck, Reset )
  begin
    if (Reset = '0') then
              State <= state_rs;
    elsif rising_edge(Ck) then
              State <= Next_State;
       end if;
  end process;

  -- Outputs Combinational Logic -----------------------------------
  OUTPUTS: process( State, i_TRG, i_TC )
  begin
    -- Set output defaults:
    o_OUT <= '0';
    o_LD <= '0';
    o_EN <= '0';

    -- Set output as function of current state and input:
    CASE State IS
      when state_wt =>
                 o_LD <= '1';
      when state_ps =>
                 o_OUT <= '1';
                 if (i_TC = '0') then
                   o_EN <= '1';
                 end if;
      when OTHERS =>
                 o_OUT <= '0';
                 o_LD <= '0';
                 o_EN <= '0';
    END case;
  end process;

END behavioral;
