------------------------------------------------------------
-- Deeds (Digital Electronics Education and Design Suite)
-- VHDL Code generated on (09/05/2023, 09:01:06)
--      by Deeds (Digital Circuit Simulator)(Deeds-DcS)
--      Ver. 2.50.200 (Feb 18, 2022)
-- Copyright (c) 2002-2022 University of Genoa, Italy
--      Web Site:  https://www.digitalelectronicsdeeds.com
------------------------------------------------------------
-- FPGA Board: "DE0-CV Board"
-- Chip FPGA: Intel/Altera Cyclone(r) V (5CEBA4F23C7)
-- Proprietary EDA Tool: Quartus(r) II (Ver = 12.1sp1)
------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.all;


ENTITY Pulser_DE0CV IS
  PORT( 
    --------------------------------------> Clocks:
    iCLOCK_50MHz: IN  std_logic;   --> PIN_V15
                                   --> "iCLK"  Clock: 2 Hz Slow Clock Mode = (Sw[09]), (Key[01]), (LEDR[09])
    --------------------------------------> Inputs:
    iTRG:         IN  std_logic;   --> PIN_M6,   Push-Button: Key[03] High (if pressed)
    inReset:      IN  std_logic;   --> PIN_P22,  Push-Button: Reset_N Low (if pressed)
    iTIME_03:     IN  std_logic;   --> PIN_T12,  Switch: Sw[03]
    iTIME_02:     IN  std_logic;   --> PIN_T13,  Switch: Sw[02]
    iTIME_01:     IN  std_logic;   --> PIN_V13,  Switch: Sw[01]
    iTIME_00:     IN  std_logic;   --> PIN_U13,  Switch: Sw[00]
    --------------------------------------> Outputs:
    oOUT:         OUT std_logic;   --> PIN_L2,   LED (Red): LEDR[08]
    oLEDS_03:     OUT std_logic;   --> PIN_Y3,   LED (Red): LEDR[03]
    oLEDS_02:     OUT std_logic;   --> PIN_W2,   LED (Red): LEDR[02]
    oLEDS_01:     OUT std_logic;   --> PIN_AA1,  LED (Red): LEDR[01]
    oLEDS_00:     OUT std_logic;   --> PIN_AA2,  LED (Red): LEDR[00]
    oQ3_Q0_03:    OUT std_logic;   --> PIN_U1,   LED (Red): LEDR[07]
    oQ3_Q0_02:    OUT std_logic;   --> PIN_U2,   LED (Red): LEDR[06]
    oQ3_Q0_01:    OUT std_logic;   --> PIN_N1,   LED (Red): LEDR[05]
    oQ3_Q0_00:    OUT std_logic;   --> PIN_N2,   LED (Red): LEDR[04]
    --------------------------------------> Added Inputs:
    iSLOW_Sw09:   IN  std_logic;   --> PIN_AB12
                                   --> "iCLK"  Switch: Sw[09]
    iPULSE_Key01: IN  std_logic;   --> PIN_W9
                                   --> "iCLK"  Push-Button: Key[01]
    --------------------------------------> Added Outputs:
    oCLOCK_LedR09: OUT std_logic;  --> PIN_L1,   LED (Red): LEDR[09]
    --------------------------------------> Default Outputs:
    oPIN_U21:     OUT std_logic;   --> PIN_U21,  Seven Segm. Display:  HEX 0 0 (a)
    oPIN_V21:     OUT std_logic;   --> PIN_V21,  Seven Segm. Display:  HEX 0 1 (b)
    oPIN_W22:     OUT std_logic;   --> PIN_W22,  Seven Segm. Display:  HEX 0 2 (c)
    oPIN_W21:     OUT std_logic;   --> PIN_W21,  Seven Segm. Display:  HEX 0 3 (d)
    oPIN_Y22:     OUT std_logic;   --> PIN_Y22,  Seven Segm. Display:  HEX 0 4 (e)
    oPIN_Y21:     OUT std_logic;   --> PIN_Y21,  Seven Segm. Display:  HEX 0 5 (f)
    oPIN_AA22:    OUT std_logic;   --> PIN_AA22, Seven Segm. Display:  HEX 0 6 (g)
    oPIN_AA20:    OUT std_logic;   --> PIN_AA20, Seven Segm. Display:  HEX 1 0 (a)
    oPIN_AB20:    OUT std_logic;   --> PIN_AB20, Seven Segm. Display:  HEX 1 1 (b)
    oPIN_AA19:    OUT std_logic;   --> PIN_AA19, Seven Segm. Display:  HEX 1 2 (c)
    oPIN_AA18:    OUT std_logic;   --> PIN_AA18, Seven Segm. Display:  HEX 1 3 (d)
    oPIN_AB18:    OUT std_logic;   --> PIN_AB18, Seven Segm. Display:  HEX 1 4 (e)
    oPIN_AA17:    OUT std_logic;   --> PIN_AA17, Seven Segm. Display:  HEX 1 5 (f)
    oPIN_U22:     OUT std_logic;   --> PIN_U22,  Seven Segm. Display:  HEX 1 6 (g)
    oPIN_Y19:     OUT std_logic;   --> PIN_Y19,  Seven Segm. Display:  HEX 2 0 (a)
    oPIN_AB17:    OUT std_logic;   --> PIN_AB17, Seven Segm. Display:  HEX 2 1 (b)
    oPIN_AA10:    OUT std_logic;   --> PIN_AA10, Seven Segm. Display:  HEX 2 2 (c)
    oPIN_Y14:     OUT std_logic;   --> PIN_Y14,  Seven Segm. Display:  HEX 2 3 (d)
    oPIN_V14:     OUT std_logic;   --> PIN_V14,  Seven Segm. Display:  HEX 2 4 (e)
    oPIN_AB22:    OUT std_logic;   --> PIN_AB22, Seven Segm. Display:  HEX 2 5 (f)
    oPIN_AB21:    OUT std_logic;   --> PIN_AB21, Seven Segm. Display:  HEX 2 6 (g)
    oPIN_Y16:     OUT std_logic;   --> PIN_Y16,  Seven Segm. Display:  HEX 3 0 (a)
    oPIN_W16:     OUT std_logic;   --> PIN_W16,  Seven Segm. Display:  HEX 3 1 (b)
    oPIN_Y17:     OUT std_logic;   --> PIN_Y17,  Seven Segm. Display:  HEX 3 2 (c)
    oPIN_V16:     OUT std_logic;   --> PIN_V16,  Seven Segm. Display:  HEX 3 3 (d)
    oPIN_U17:     OUT std_logic;   --> PIN_U17,  Seven Segm. Display:  HEX 3 4 (e)
    oPIN_V18:     OUT std_logic;   --> PIN_V18,  Seven Segm. Display:  HEX 3 5 (f)
    oPIN_V19:     OUT std_logic;   --> PIN_V19,  Seven Segm. Display:  HEX 3 6 (g)
    oPIN_U20:     OUT std_logic;   --> PIN_U20,  Seven Segm. Display:  HEX 4 0 (a)
    oPIN_Y20:     OUT std_logic;   --> PIN_Y20,  Seven Segm. Display:  HEX 4 1 (b)
    oPIN_V20:     OUT std_logic;   --> PIN_V20,  Seven Segm. Display:  HEX 4 2 (c)
    oPIN_U16:     OUT std_logic;   --> PIN_U16,  Seven Segm. Display:  HEX 4 3 (d)
    oPIN_U15:     OUT std_logic;   --> PIN_U15,  Seven Segm. Display:  HEX 4 4 (e)
    oPIN_Y15:     OUT std_logic;   --> PIN_Y15,  Seven Segm. Display:  HEX 4 5 (f)
    oPIN_P9:      OUT std_logic;   --> PIN_P9,   Seven Segm. Display:  HEX 4 6 (g)
    oPIN_N9:      OUT std_logic;   --> PIN_N9,   Seven Segm. Display:  HEX 5 0 (a)
    oPIN_M8:      OUT std_logic;   --> PIN_M8,   Seven Segm. Display:  HEX 5 1 (b)
    oPIN_T14:     OUT std_logic;   --> PIN_T14,  Seven Segm. Display:  HEX 5 2 (c)
    oPIN_P14:     OUT std_logic;   --> PIN_P14,  Seven Segm. Display:  HEX 5 3 (d)
    oPIN_C1:      OUT std_logic;   --> PIN_C1,   Seven Segm. Display:  HEX 5 4 (e)
    oPIN_C2:      OUT std_logic;   --> PIN_C2,   Seven Segm. Display:  HEX 5 5 (f)
    oPIN_W19:     OUT std_logic    --> PIN_W19,  Seven Segm. Display:  HEX 5 6 (g)
    ------------------------------------------------------
    );
END Pulser_DE0CV;


ARCHITECTURE structural OF Pulser_DE0CV IS 

  ----------------------------------------> Components:
  COMPONENT ClockScaler IS
    PORT( iMClk: IN  std_logic;   -- Master Clock
          iH4:   IN  std_logic;   -- iH4..iH0 = "high" frequency selection
          iH3:   IN  std_logic;
          iH2:   IN  std_logic;
          iH1:   IN  std_logic;
          iH0:   IN  std_logic;
          iL3:   IN  std_logic;   -- iL3..iL0 = "low" frequency selection
          iL2:   IN  std_logic;   --                  and Button Modes
          iL1:   IN  std_logic;
          iL0:   IN  std_logic;
          iSwch: IN  std_logic;   -- Switch (low: iH<n> selection, high: iL<n> selection)
          iBut:  IN  std_logic;   -- Button for manual pulsed Clock
          oSClk: OUT std_logic;   -- Output Clock
          oLed:  OUT std_logic 	-- Slow "Clock Pulse" Led
          );
  END COMPONENT;
  --
  COMPONENT Counter4b IS
    PORT( Ck : IN std_logic;
          nCL: IN std_logic;
          LD : IN std_logic;
          ENP: IN std_logic;
          ENT: IN std_logic;
          UD : IN std_logic;
          P3 : IN std_logic;
          P2 : IN std_logic;
          P1 : IN std_logic;
          P0 : IN std_logic;
          Q3 : OUT std_logic;
          Q2 : OUT std_logic;
          Q1 : OUT std_logic;
          Q0 : OUT std_logic;
          Tc : OUT std_logic );
  END COMPONENT;

  ----------------------------------------> Finite State Machine(s):
  COMPONENT Fsm1_Pulser_EN IS
    PORT( ----------------------------------->Clock & Reset:
          Ck:    IN std_logic;
          Reset: IN std_logic;
          ----------------------------------->Inputs:
          i_TRG: IN std_logic;
          i_TC:  IN std_logic;
          ----------------------------------->Outputs:
          o_OUT: OUT std_logic;
          o_LD:  OUT std_logic;
          o_EN:  OUT std_logic
          -------------------------------------------
          );
  END COMPONENT;

  ----------------------------------------> Signals:
  SIGNAL S001: std_logic;
  SIGNAL S002: std_logic;
  SIGNAL S003: std_logic;
  SIGNAL S004: std_logic;
  SIGNAL S005: std_logic;
  SIGNAL S006: std_logic;
  SIGNAL S007: std_logic;
  SIGNAL S008: std_logic;
  SIGNAL S009: std_logic;
  SIGNAL S010: std_logic;
  SIGNAL S011: std_logic;
  SIGNAL S012: std_logic;
  SIGNAL S013: std_logic;
  SIGNAL S014: std_logic;
  SIGNAL S015: std_logic;
  SIGNAL S016: std_logic;
  SIGNAL S017: std_logic;

  ----------------------------------------> Added Signals:
  SIGNAL SSLOW_Sw09: std_logic;
  SIGNAL SPULSE_Key01: std_logic;
  SIGNAL iCLK: std_logic;
  SIGNAL SCLOCK_LedR09: std_logic;


BEGIN -- structural

  ----------------------------------------> Input:
  S002 <= NOT iTRG;
  S005 <= iCLK;
  S007 <= inReset;
  S014 <= iTIME_00;
  S015 <= iTIME_01;
  S016 <= iTIME_02;
  S017 <= iTIME_03;

  ----------------------------------------> Output:
  oOUT <= S008;
  oLEDS_00 <= S014;
  oLEDS_01 <= S015;
  oLEDS_02 <= S016;
  oLEDS_03 <= S017;
  oQ3_Q0_00 <= S010;
  oQ3_Q0_01 <= S011;
  oQ3_Q0_02 <= S012;
  oQ3_Q0_03 <= S013;

  ----------------------------------------> Constants:
  S004 <= '0';
  S001 <= '1';
  oPIN_U21  <= '1';
  oPIN_V21  <= '1';
  oPIN_W22  <= '1';
  oPIN_W21  <= '1';
  oPIN_Y22  <= '1';
  oPIN_Y21  <= '1';
  oPIN_AA22 <= '1';
  oPIN_AA20 <= '1';
  oPIN_AB20 <= '1';
  oPIN_AA19 <= '1';
  oPIN_AA18 <= '1';
  oPIN_AB18 <= '1';
  oPIN_AA17 <= '1';
  oPIN_U22  <= '1';
  oPIN_Y19  <= '1';
  oPIN_AB17 <= '1';
  oPIN_AA10 <= '1';
  oPIN_Y14  <= '1';
  oPIN_V14  <= '1';
  oPIN_AB22 <= '1';
  oPIN_AB21 <= '1';
  oPIN_Y16  <= '1';
  oPIN_W16  <= '1';
  oPIN_Y17  <= '1';
  oPIN_V16  <= '1';
  oPIN_U17  <= '1';
  oPIN_V18  <= '1';
  oPIN_V19  <= '1';
  oPIN_U20  <= '1';
  oPIN_Y20  <= '1';
  oPIN_V20  <= '1';
  oPIN_U16  <= '1';
  oPIN_U15  <= '1';
  oPIN_Y15  <= '1';
  oPIN_P9   <= '1';
  oPIN_N9   <= '1';
  oPIN_M8   <= '1';
  oPIN_T14  <= '1';
  oPIN_P14  <= '1';
  oPIN_C1   <= '1';
  oPIN_C2   <= '1';
  oPIN_W19  <= '1';

  ----------------------------------------> Component Mapping:

  SSLOW_Sw09 <= iSLOW_Sw09;
  SPULSE_Key01 <= NOT iPULSE_Key01;
  oCLOCK_LedR09 <= SCLOCK_LedR09;

  ClockScaler_iCLK: ClockScaler PORT MAP ( 
      iCLOCK_50MHz, '1', '0', '1', '0', '0', '1', '1', '1', '1',
      SSLOW_Sw09, SPULSE_Key01, iCLK, SCLOCK_LedR09 );

  C680: Counter4b PORT MAP ( S005, S007, S003, S006, S001, S004, 
                             S017, S016, S015, S014, S013, S012, 
                             S011, S010, S009 );
  C704: Fsm1_Pulser_EN PORT MAP ( S005, S007, S002, S009, S008, 
                                  S003, S006 );
END structural;
